/* Project
   Sharon Price
   Salman Baset
   Bogdan Caprita
*/

#include "xbasic_types.h"
#include "xio.h"
#include "xintc_l.h"
#include "xuartlite_l.h"
#include "queue.h"


#include "ether_reg.h"

//WORD packet[100];

Xuint16 pack_buf[256]; // 512 bytes
BYTE *packet;

CONFIGNE configs[2];  


#define W 640
#define H 480

#define C_WIDTH 8
#define C_HEIGHT 8

#define WIDTH  (W/C_WIDTH)
#define HEIGHT (H/C_HEIGHT)


#define VGA_START 0x00800000


#define RED 0xE0
#define GREEN 0x1C
#define BLUE 0x03
#define BLACK 0
#define FONT_COLOR RED | GREEN


// defined in isr.c
extern void uart_handler(void *callback);
extern int uart_interrupt_count;
extern char uart_character;

// flag to check if it's a printable char
int isPrint;

// the circular buffer
struct queue q;

int x, y;

void printChar(char c, int x, int y)
{
  //XIo_Out8(VGA_START + (y-1) * WIDTH + x, c);
  char ch[2]={'\0'};
  ch[1]=c;
  print(c);
}


/* scrolls screen up by amount lines */
int scrolling(int amount)
{
  //memmove(VGA_START, VGA_START + amount*WIDTH, (HEIGHT - amount) * WIDTH);
  //memset(VGA_START + (HEIGHT - amount) * WIDTH, 0, amount * WIDTH);
}

/*
 * setup_interrupts: Initialize the interrupt sources and handlers
 *
 * Should be called once when the system starts
 *
 * The main _interrupt_handler() function from Xilinx
 *
 * Saves and restores CPU context, etc.
 *
 * Sees which interrupts are pending, and for each it
 *     acknowledges the interrupt and
 *     calls a user-defined interrupt handler in Xintc_InterruptVectorTable
 *
 * Place interrupt service routines in isr.c to ensure they are placed in
 * the proper memory segment.
 */
void setup_interrupts()
{
  /*
   * Reset the interrupt controller peripheral
   */

  /* Disable the interrupt signal */
  XIntc_mMasterDisable(XPAR_INTC_SINGLE_BASEADDR);

  /* Disable all interrupt sources */
  XIntc_mEnableIntr(XPAR_INTC_SINGLE_BASEADDR,0);

  /* Acknowledge all possible interrupt sources
     to make sure none are pending */
  XIntc_mAckIntr(XPAR_INTC_SINGLE_BASEADDR, 0xffffffff);

  /*
   * Install the UART interrupt handler
   */
 
  XIntc_InterruptVectorTable[XPAR_INTC_MYUART_INTERRUPT_INTR].Handler =
    uart_handler;

  /*
   * Enable interrupt sources
   */

  /* Enable CPU interrupts */
  microblaze_enable_interrupts();

  /* Enable interrupts from the interrupt controller */
  XIntc_mMasterEnable(XPAR_INTC_SINGLE_BASEADDR);

  /* Tell the interrupt controller to accept interrupts from the UART */
  XIntc_mEnableIntr(XPAR_INTC_SINGLE_BASEADDR, XPAR_MYUART_INTERRUPT_MASK);
  
  /* Enable UART interrupt generation */
  XUartLite_mEnableIntr(XPAR_MYUART_BASEADDR);
}

void send_data(int len, BYTE* data) {

  int i=0;
  //print("In Send Data Function \r\n");

  if(len < 46) {
    for(i=14+len;i<14+46;i++)
      data[i]=0;
    len=46;
  }

  if(len%2!=0) {
    len++;
    data[13+len]='X';
  }

  
  /*for(i=0;i<14+len;i++){
    putnum(data[i]);
    print(" ");
    if(i%10 == 0 && i!= 0) {
      print("\r\n");
    }
  }
  */
  
  //  print("\r\nSending\r\n");

  send(len,(WORD*)data);

  //print("\r\n");
  
}

int main()
{
  char c;
  int i, tmp_1, len;
  char buf[2], buf2[2];
  char buffer[10];
  int line_count=0;
  BYTE line[100];
  WORD *pkt;
  WORD word;
  WORD curr;
  CONFIGNE* cp;

  cp = &configs[0];
  packet = (BYTE*)pack_buf;


  // Enable the instruction cache: makes the code run 6 times faster
  //microblaze_enable_icache();
 
  microblaze_enable_icache();
  
  print("\r\n\r\n---------------Starting-------------\r\n\r\n");
  //diag();

  // reset the NIC card
  if(!init_etherne(cp)){
    print("Ethernet NIC not detected");
    return;
  }


  //Initialize the Circular Buffer
  buf[1] = '\0';
  init_queue(&q);

  //Setup Interrupts 
  setup_interrupts();

  // erasing screen
  x = -1; y = 1;
  //isPrint=1;

  //Initialize the Packet
  initpacket(line); // put some header
  

  //print("\r\nSending:\r\n");

  while (1) {
    
    // Disable interrupts
    microblaze_disable_interrupts();
    
    //Get Character from Buffer Queue
    if (dequeue(&q, buf)){
      //print(buf);
      //print("Dequeue\r\n");
      microblaze_enable_interrupts();
      
      switch (buf[0]){
      case '\r': 
	/*print(" ");
	for(i=0;i<line_count;i++){
	  buf[0]=line[i];
	  print(buf);
	}
	*/
	send_data(line_count, (BYTE*)line);
	line_count=0;
	x = -1; break;
      case '\n':
	line_count=0;
	y++; break;
      case 8 :
	line[14+ line_count ] =  0;
      default:
	line[14+line_count]=buf[0];
	line_count++;

	isPrint = 1;
	x ++;
	if (x > WIDTH-1 ){
	  x = 0;
	  y ++;
	}
      }

   } else {
    //Enable interrupts
      microblaze_enable_interrupts();    
   }


    curr=0;
    buf2[1]='\0';
    if( (curr=innic(ISR)&0x01)!=0){
      receive(&len, packet);

      //      print("\r\nReceived: ");
      //putnum(len);
      /*for(i=14;i<len-4;i++){
	
	buf2[0] = (char)packet[i];

	if(packet[i]==0x00)
	  break;

	print(buf2);
	}*/
      packet[len-5] = 0;
      print(packet+14);
      print("\n");

      //print("\r\n\r\nSending: \r\n");
      //print("\r\nSending: \r\n");
    }
 
    // see if need to scroll
    //    microblaze_disable_interrupts();
    if (y > HEIGHT){      
      y -= 1;      
      //scrolling(1);
    }
     
  }
  
  return 0;

}//main
