#include "ether.h"

static BYTE incr = 0;

BYTE dmaWrite(WORD *data, WORD addr, WORD len){
  int i, j, h;
  WORD counter;
  WORD word;

  counter = len>>1;
  //counter = len;

  outnic(RSAR0, (addr&0xff)); // set DMA starting address
  outnic(RSAR1, (addr>>8));

  outnic(ISR, 0xFF); // clear ISR

  outnic(RBCR0, (len&0xff)); // set Remote DMA Byte Count
  outnic(RBCR1, (len>>8));

  outnic(TBCR0, (len&0xff)); // set Transmit Byte Count
  outnic(TBCR1, (len>>8));

  outnic(CMDR, 0x12); // start the DMA write

  // change order of MS/LS since DMA
  // writes LS byte in 15-8, and MS byte in 7-0
  for(i=0; i<counter; i++){
    word = (data[i]<<8)|(data[i]>>8);
    outnic(DATAPORT, word);//i+(incr<<8));//(data[i]));
    //    outnic(DATAPORT, word);
    //for(j=0; j<100000; j++);
    //outnic((0x1E*2),0x00);
    //outnic(DATAPORT, (i<<8)+incr);
  }
  incr++;

  if(!(innic(ISR)&0x40)){
    print("DMA did not finish\r\n");
    return 1;
  }

  outnic(TPSR, TXSTART); // set Transmit Page Start Register
  outnic(CMDR, 0x24); // start transmission
  
  j=100;
  while(j-->0 && !(innic(ISR)&0x02));
  if(!j){
    return 1;
  }

  outnic(ISR,0xFF);

  return 0;
}
